// Pin definitions for sensor RGB
#define S0 5
#define S1 6
#define S2 7
#define S3 8
#define sensorOut 10

// Variables for RGB values
int Red, Green, Blue;

void setup() {
  // Pin mode for sensor RGB
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(sensorOut, INPUT);
  
  // Setting frequency-scaling to 20%
  digitalWrite(S0, HIGH);
  digitalWrite(S1, LOW);
  
  // Begin serial communication
  Serial.begin(115200);
}

void loop() {
  // Setting red filtered photodiodes to be read
  digitalWrite(S2, LOW);
  digitalWrite(S3, LOW);
  // Reading the output frequency
  int frequency = pulseIn(sensorOut, LOW);
  // Remapping the value of the frequency to the RGB Model of 0 to 255
  Red = map(frequency, 25, 72, 0, 255);
  
  // Setting Green filtered photodiodes to be read
  digitalWrite(S2, HIGH);
  digitalWrite(S3, HIGH);
  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  // Remapping the value of the frequency to the RGB Model of 0 to 255
  Green = map(frequency, 30, 90, 0, 255);
  
  // Setting Blue filtered photodiodes to be read
  digitalWrite(S2, LOW);
  digitalWrite(S3, HIGH);
  // Reading the output frequency
  frequency = pulseIn(sensorOut, LOW);
  // Remapping the value of the frequency to the RGB Model of 0 to 255
  Blue = map(frequency, 25, 70, 0, 255);
  
  // Printing RGB values to serial monitor
  Serial.print("R= ");
  Serial.print(Red);
  Serial.print(" G= ");
  Serial.print(Green);
  Serial.print(" B= ");
  Serial.println(Blue);
  
  // Delay for stability
  delay(100);
}

